/************************************************************************************/
/*  Program name CAPAPEXT_PAY_SCHEDULE.sql                                          */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_PAY_SCHEDULE';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_PAY_SCHEDULE.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		B.Name	OU_Name
	FROM
		AP_PAYMENT_SCHEDULES_ALL	F,
		HR_ALL_ORGANIZATION_UNITS	B,
		HR_ORGANIZATION_INFORMATION	I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information'
	ORDER BY
		F.Invoice_ID;

	lv_Bank_Name		VARCHAR2(60);
	lv_Bank_AccName		VARCHAR2(80);
		
BEGIN
	lv_NGO		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			lv_Bank_Name	:=	NULL;
			lv_Bank_AccName	:=	NULL;
			CAPBREXT_COMMON.GetExtBankAcc(C1.External_Bank_Account_ID,lv_Bank_Name,lv_Bank_AccName);

			UTL_FILE.PUT_LINE(
				lv_UTL_File,
					C1.Invoice_ID||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
				C1.Payment_Cross_Rate||CHR(9)||
				C1.Payment_Num||CHR(9)||
				C1.Amount_Remaining||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
				C1.Discount_Date||CHR(9)||
				C1.Due_Date||CHR(9)||
				C1.Future_Pay_Due_Date||CHR(9)||
				C1.Gross_Amount||CHR(9)||
				C1.Hold_Flag||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Payment_Method_Lookup_Code||CHR(9)||
				C1.Payment_Priority||CHR(9)||
				C1.Payment_Status_Flag||CHR(9)||
				C1.Second_Discount_Date||CHR(9)||
				C1.Third_Discount_Date||CHR(9)||
					C1.Batch_ID||CHR(9)||
				C1.Discount_Amount_Available||CHR(9)||
				C1.Second_Disc_Amt_Available||CHR(9)||
				C1.Third_Disc_Amt_Available||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Discount_Amount_Remaining||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Global_Attribute_Category||CHR(9)||
				C1.Global_Attribute1||CHR(9)||
				C1.Global_Attribute2||CHR(9)||
				C1.Global_Attribute3||CHR(9)||
				C1.Global_Attribute4||CHR(9)||
				C1.Global_Attribute5||CHR(9)||
				C1.Global_Attribute6||CHR(9)||
				C1.Global_Attribute7||CHR(9)||
				C1.Global_Attribute8||CHR(9)||
				C1.Global_Attribute9||CHR(9)||
				C1.Global_Attribute10||CHR(9)||
				C1.Global_Attribute11||CHR(9)||
				C1.Global_Attribute12||CHR(9)||
				C1.Global_Attribute13||CHR(9)||
				C1.Global_Attribute14||CHR(9)||
				C1.Global_Attribute15||CHR(9)||
				C1.Global_Attribute16||CHR(9)||
				C1.Global_Attribute17||CHR(9)||
				C1.Global_Attribute18||CHR(9)||
				C1.Global_Attribute19||CHR(9)||
				C1.Global_Attribute20||CHR(9)||
					C1.External_Bank_Account_ID||CHR(9)||
				C1.Inv_Curr_Gross_Amount||CHR(9)||
				C1.Checkrun_ID||CHR(9)||
				CAPBREXT_COMMON.GetBatchName(C1.Batch_ID)||CHR(9)||
				CAPBREXT_COMMON.GetInvoiceNumber(C1.Invoice_ID)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				C1.OU_Name||CHR(9)||
				lv_Bank_Name||CHR(9)||
				lv_Bank_AccName
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;

END;
/